#!/bin/sh
# :
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with  
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE"  
# document which accompanies distribution. 
  
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF_INTRO


     Check for  quiet_routed - Move /usr/sbin/routed to /usr/sbin/routed.asetorigional
     then build a wrapper starting routed -q. This is done to be compatible
     with the ASET package.

EOF_INTRO

}

Check() {

if [ -f /usr/sbin/routed.asetoriginal ]
  then
	t_echo 2 "route daemon already configured to be opaque. PASSES CHECK"
else
	t_echo 0 " route daemon is advertising routes: FAILS CHECK"
fi

}

Fix() {
if [ -f /usr/sbin/routed.asetoriginal ]
  then
        t_echo 2 "route daemon already configured to be opaque. PASSES CHECK"
else
	/bin/mv /usr/sbin/routed /usr/sbin/routed.asetoriginal
	if [ $? -ne 0 ]
	then   
	t_echo 1
	t_echo 1 "Could not rename /usr/sbin/routed"
	exit 1
	fi
fi

t_echo 2
echo "#! /bin/sh" > /usr/sbin/routed
if [ $? -ne 0 ]
	then   
	t_echo 1
	t_echo 1 "Could not create new ${ROUTED} script."
	exit 1
fi
echo "/usr/sbin/routed.asetoriginal -q \$*" >> /usr/sbin/routed
/bin/chmod 0755 /usr/sbin/routed
if [ $? -ne 0 ]
	then
	t_echo 1
	t_echo 1 "Could not chmod new ${ROUTED} script."
	exit 1
	fi

t_echo 0
t_echo 0 " Renamed in.routed to in.routed.asetorigional."
t_echo 0 " Installed new in.routed script."


}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        t_echo 1 " "
;;
esac

