:
#
# version 3.0 Sep 25 11:21:02 PDT 1998
# rev 3.01 Tue Nov  3 17:46:47 PST 1998
#       zen - changed /usr/ucb/echo -n to nawk stuff.
# version 3.4

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with
# respect to its usage or its effect upon hardware or computer
# systems, and maintains copyright as set out in the "LICENSE"
# document which accompanies distribution.
#
#
# Attempts to calculate files which Titan will modify in order
# to make backup copies... Note that this does NOT apply to the
# file permission change modules file-own.sh, ziplock.sh.
# All files backed up are fully qualifed from '/' for ease of
# recovery
#

# Assumes that you have written a module using fully qualified paths
# to commands and then run lib/swapcomms.sh to force utilization of the
# command variables in lib/misc_functions.sh a minimum set of which are
# supplied in misc_functions.sh as follows:
#
# export RM RMF MV MVF LN LNS ED EX SED AWK NAWK GREP GREPS FGREP EGREP
# export TOUCH CHOWN CHMOD CHGRP GREPI EGREPI FGREPS FGREPIS FGREPSI
# export EGREPSI EGREPIS EGREPS 


 if [ -r ${TITANHOME}/.trunrc ]; then 
  . ${TITANHOME}/.trunrc 
  export TITANHOME 
 else

  if [ -r ./.trunrc ]; then
   . ./.trunrc
   export TITANHOME
  else
   TITANHOME=`pwd`
   export TITANHOME
  fi

 fi

PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MODULE_NAME=`basename $0`

case ${MODULE_NAME} in
 "untit.sh")
  exit 0
 ;;
 *)
 ;;
esac

#
# Debug  here
t_echo 1 "Started from $0"
# exit 0
#
# Include some meaningful stuff and includes from lib
#
. $TITANHOME/lib/misc_functions.sh
DATE=`/bin/date +%m%d%y%H%M%S`
export DATE
. $TITANHOME/lib/misc_functions.sh
DATE=`/bin/date +%m%d%y%H%M`

HOST=`/bin/uname -n`

if [ "$MODULE_NAME" = "untit.sh" ]; then
REVDIR=$TITANHOME/Backup/$HOST
REVARCHIVES=`ls ${REVDIR}/*`
REVDATA=${REVDIR}/REVERSE.tmp
SAVELIST=`ls ${REVDIR}/*/SaveList.*`
else
REVDIR=$TITANHOME/Backup/$HOST/$MODULE_NAME
REVARCHIVES=`ls ${REVDIR}/*`
REVDATA=${REVDIR}/REVERSE.tmp
SAVELIST=`ls ${REVDIR}/*/SaveList.*`
fi

#
# Recover from a backup dir in $TITANHOME/Backup

GetRecoverInfo() {

if [ -d $REVDIR ]; then
 t_echo 1 "Backup dir $REVDIR - OK"
 t_echo 1 " "
 t_echo 1 "Available archives: "

 for NAME in ${SAVELIST}
  do
   t_echo 1 "	`basename $NAME`"
 done

else
 t_echo 1 "No backup dir in : $REVDIR - Nothing to recover"
 exit 1
fi

 nawk 'BEGIN {printf("Enter name of savelist: ")}' /dev/null
 read REVLIST
 REVLIST=`echo $REVLIST | awk -F"." '{print $2}'`
 if [ -d $REVDIR ]; then
 t_echo 1 "Set directory for recover to: $REVDIR/$REVLIST"
 t_echo 1 "Recovering files now....."

 cd $REVDIR/$REVLIST
 pwd
 FILES=`find . -print | grep -v Savelist | sed -e 's/^.//'`
 t_echo 1 "Moving current Titan files aside to foo.revtitan..."

 for REVFILE in ${FILES}; do
 if [ -r ${REVFILE} -a ! -d ${REVFILE} ]; then
 # /bin/mv ${REVFILE} ${REVFILE}.revtitan
 t_echo 1 "mv ${REVFILE} ${REVFILE}.revtitan"
 fi
 done
 t_echo 1 "Restoring saved files from ${REVDIR}/${REVLIST}..." 
 
 cd ${REVDIR}/${REVLIST}
 tar cvpf - `ls | grep -v Savelist`|(cd /;tar tvpf - ) 

 t_echo 1 "Done - Restoring perms using setfacl in ${SAVELIST}..." 

 /bin/sh -x ${SAVELIST}

 t_echo 1 "Done - Removing Titan files named foo.revtitan..."

 for REVFILE in `cat ${NAME}`
 do
 if [ -r /${REVFILE}.revtitan ]; then
 # /bin/rm /${REVFILE} /${REVFILE}.revtitan
 t_echo 1 "rm /${REVFILE} /${REVFILE}.revtitan"
 fi
 done
 t_echo 1 "Done"

 t_echo 1 "Recovery complete..."
 /bin/rm -f ${REVDATA}
 exit 0
 else
 t_echo 1 "Nope - Don't see ${NAME} - Try again"
 t_echo 1 "No backup dir in : $REVDIR - Nothing to recover"
 nawk 'BEGIN {printf("Alternate locations for backups (<dirname>/N): ")}' /dev/null
 read DIRNAME

 case $DIRNAME in
  [nN]) t_echo 1 "Okay - Exiting";exit 1;;
  *)
  t_echo 1 "Checking for ${DIRNAME} .... "
  REVDIR=${DIRNAME}
  export REVDIR
  GetRecoverInfo
  ;;
 esac
 fi

}

Usage() {
t_echo 1 "Usage: $0 -[g,r]
Where: $0 -g shows all available recovery files
Where: $0 -r recovers files from your selected savelist"
}

#
#  We assume we got called to recover...
#
#if [ $# -lt 1 ]; then
 #Usage
 #exit 1
#fi

#
# For debug force $1 = GetRecoverInfo
Input=g
export Input

case $Input in
 -[gG]|[gG])
	GetRecoverInfo
 ;;
 -[rR]|[rR])
	GetRecoverInfo
	ReverseTitan
 ;;
 *)
 	Usage
 ;;
esac

exit 0
