:
# eeprom.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/usr/sbin/eeprom'

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

OS=`uname -r`

case $OS in
  5*)
   EEPROM='/usr/sbin/eeprom'
  ;;
  4*)
   EEPROM='/usr/etc/eeprom'
  ;;
 *)
   t_echo 1 "No valid OS for EEPROM"
   exit 1
;;
esac

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi
 

Intro() {

cat << EOF

 $MYNAME :This script checks the value of the eeprom security-mode variable.

 This is typically a CHECK ONLY since it requires a system administrators 
 input in selecting a password for the eeprom in most cases.  You can only
 set this from the boot prompt should you wish.  Available settings for
 eeprom security-mode are:

	command = Password to boot with args
	full    = Password to boot at all
	none    = We don't really care who reboots me....

EOF
}

CheckEeprom() {

	if [ -x ${EEPROM} ]; then
   t_echo 2 " Architecture = `uname -m`"
	    SMODE=`${EEPROM} security-mode | awk -F"=" '{print $2}'`
	    if [ -n "$SMODE" ]; then
	    case ${SMODE} in
		command)
                 t_echo 1 "         eeprom security mode = command - PASSES CHECK"
                 t_echo 3 "   "
		 exit 1
		;;
		full)
                 t_echo 1 "         eeprom security mode = full - PASSES CHECK"
                 t_echo 3 "   "
		 exit 1
		;;
		none)
                 t_echo 0 "         eeprom security-mode is currently NOT SET! - FAILS CHECK"
                 t_echo 0 "         We strongly recommend it be set to -command- by the Administration Staff "
		 exit 1
		;;
		*)
                 t_echo 1 "         Unknown status - Rerun with $MYNAME -v"
		 exit 1
		;;
	     esac
	  else
             t_echo 1 "         ERROR Eeprom security-mode not supported on this host"
  	     exit 1
          fi
	fi
}

action=$1
case ${action} in
 -[Ii]*)
 Intro
 ;;
 -[Ff]*)
 CheckEeprom
 ;;
 -[Vv]*)
 CheckEeprom
 ;;
 *)
        t_echo 1 "         ERROR:Invalid arg $action"
        t_echo 1 "         ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac
