:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022
#
# Derived from the in.ftpd(1M) manual page supplied with SunOS 5.5.1
# Copyright Sun Microsystems Computer Corporation - SunOS 5.5.1
# Last change: 7 Nov 1995
# SunOS is a registered trademark of Sun Microsystems Computer Corporation
#
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

#
# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`

OS=`uname -r`

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

#
# Working functions here
#

MakeFTPAcct() { 

     t_echo 0 Setting up anonymous ftp area ${ftphome}

     t_echo 2 Setting up ${ftphome} etc bin lib etc....
     # Ensure that the /usr/bin directory exists
     if [ ! -d ${ftphome}/usr/bin ]; then
         mkdir -p ${ftphome}/usr/bin
     fi

     cp /usr/bin/ls ${ftphome}/usr/bin
     chmod -R 111 ${ftphome}/usr/bin/ls

     # Now set the ownership and modes to match the man page
     chown -R root ${ftphome}/usr/bin
     chmod -R 555 ${ftphome}/usr/bin

     # this may not be the right thing to do
     # but we need the bin -> usr/bin link
     if [ -r ${ftphome}/bin ]; then
         mv -f ${ftphome}/bin ${ftphome}/Obin
     fi
     ln -s usr/bin ${ftphome}

     # Ensure that the /usr/lib and /etc directories exist
     if [ ! -d ${ftphome}/usr/lib ]; then
         mkdir -p ${ftphome}/usr/lib
     fi
     if [ ! -d ${ftphome}/etc ]; then
         mkdir -p ${ftphome}/etc
     fi

     #Most of the following are needed for basic operation, except
     #for libnsl.so, nss_nis.so, libsocket.so, and straddr.so which are
     #needed to resolve NIS names.

     t_echo 2 "Building ld.so libraries in ${ftphome}/usr/lib ...."
     cp /usr/lib/ld.so /usr/lib/ld.so.1 ${ftphome}/usr/lib

     t_echo 2 "Building resolver/nis libraries in ${ftphome}/usr/lib ...."
     for lib in libc libdl libintl libw libnsl libsocket \
        nss_nis nss_nisplus nss_dns nss_files
     do
 t_echo 2 -n "${lib} " 
        cp /usr/lib/${lib}.so.1 ${ftphome}/usr/lib
        rm -f ${ftphome}/usr/lib/${lib}.so
        ln -s ./${lib}.so.1 ${ftphome}/usr/lib/${lib}.so
     done
     t_echo 2 " " 

     cp /usr/lib/straddr.so.2 ${ftphome}/usr/lib
     rm -f ${ftphome}/usr/lib/straddr.so
     ln -s ./straddr.so.2 ${ftphome}/usr/lib/straddr.so

     
     t_echo 2 "Copy /etc/passwd /etc/group /etc/netconfig ${ftphome}/etc ..."
     cp /etc/passwd /etc/group /etc/netconfig ${ftphome}/etc

     # Copy timezone database
     t_echo 2 "Creating zoneinfo in ${ftphome} ...."
     mkdir -p ${ftphome}/usr/share/lib/zoneinfo
     for name in `ls /usr/share/lib/zoneinfo` 
	do
 t_echo 2 -n "${name} " 
      cd /usr/share/lib/zoneinfo;tar cpf - ${name}|\
	(cd ${ftphome}/usr/share/lib/zoneinfo;tar xpf - )
        cd ${ftphome}/usr/share/lib/zoneinfo;chmod -R 555 ${name}
        cd ${ftphome}/usr/share/lib/zoneinfo;chown -R root ${name}
        done

 t_echo 2 " "
     # Now set the ownership and modes
     t_echo 0 "Setting modes on etc lib bin etc.... "
     chown -R root ${ftphome}/usr/lib ${ftphome}/etc
     chmod -R 555 ${ftphome}/usr/lib ${ftphome}/etc
     chmod -R 555 ${ftphome}/usr/lib/*
     chmod -R 444 ${ftphome}/etc/*

     # Ensure that the /dev directory exists
     if [ ! -d ${ftphome}/dev ]; then
         mkdir -p ${ftphome}/dev
     fi

     # make device nodes. ticotsord and udp are necessary for
     # 'ls' to resolve NIS names.

     t_echo 0 "Creating devices in ${ftphome}/dev ...."
     for device in zero tcp udp ticotsord
     do
        t_echo 2 -n "${device} " 
        line1=`ls -l /dev/${device} | awk '{print $NF}' | tr -d '.'`
        line=`ls -l ${line1}`
        major=`echo $line | awk '{print $4}' | tr -d ','`
        minor=`echo $line | awk '{print $5}' | tr -d ','`
	if [ -r ${ftphome}/dev/${device} ]; then
        mv -f ${ftphome}/dev/${device} ${ftphome}/dev/${device}.last
	fi
        mknod ${ftphome}/dev/${device} c ${major} ${minor}
	chmod 666 ${ftphome}/dev/${device}
     done
     t_echo 2 " "

     ## Now set the ownership and modes
     chown root ${ftphome}/dev
     chmod 555 ${ftphome}/dev

     t_echo 2 "Creating ${ftphome}/pub for public access ...."

     if [ ! -d ${ftphome}/pub ]; then
        mkdir -p ${ftphome}/pub
     t_echo 2 "Setting modes on ${ftphome}/pub ... "
        chmod 777 ${ftphome}/pub
     fi

     t_echo 2 Completed Setting up anonymous ftp in ${ftphome}
     t_echo 2 " "

     FTP=`grep ftp /etc/passwd`
     if [ -n "$FTP" ]; then
     chown ftp ${ftphome}/pub
     t_echo 2 Default ownership of ${ftphome}/pub is now UID 'ftp'
     t_echo 2 " "
      else
     chown sync ${ftphome}/pub
     t_echo 2 Default ownership of ${ftphome}/pub is now UID 'sync'
     t_echo 2 " "
     t_echo 2 If you do not already have an ftp user account please add
     t_echo 2 an entry to the local password database now and then run
     t_echo 2 the following command line to verify that ${ftphome}/pub is
     t_echo 2 is owned by the UID ftp :
     t_echo 2 " "
     t_echo 2  chown -R ftp ${ftphome}/pub 
     t_echo 2 " "
     fi
      

}  # End MakeFTPAcct


     #
     # handle the optional command line argument
     case $# in
        # the default location for the anon ftp comes from the passwd file
        2) if [ "$2" = "start" ]; then
              ftphome="`grep '^ftp:' /etc/passwd | cut -d: -f6`"
           else
              ftphome=$2
           fi
           ;;
        *) 
           t_echo 1 
           t_echo 1 "Usage: $MYNAME -V/F [start,<ftphome>]"
           t_echo 1 "    -V(erify)/-F(ix) mode selection"
           t_echo 1 "Where: $MYNAME -V/F start - Uses existing ftp dir in /etc/passwd"
           t_echo 1 "       $MYNAME -V/F <ftp-root-dir> - Uses $ftphome to verify/install FTP services"
           t_echo 1 " "
           t_echo 1 "Must enter a default directory for the ftp service"
           t_echo 1 "as \$2 - May NOT use either '/', '/usr', '/opt'"
           t_echo 1 
	   exit 1
           ;;
     esac

     if [ -z "${ftphome}" ]; then
        t_echo 2 "$MYNAME: ftphome must be non-null"
     fi

     # This script assumes that ftphome is neither / nor /usr so ...

	if [ "${ftphome}" = "/" -o "${ftphome}" = "/usr" -o "${ftphome}" = "/opt" ]; then
           t_echo 2 "$MYNAME: ftphome must not be / or /usr or /opt"
	fi

     # If ftphome does not exist but parent does, create ftphome
     if [ ! -d ${ftphome} ]; then
         # lack of -p below is intentional
         mkdir ${ftphome}
     fi


VrfyFTPAcct() {

BADS=0
OK=0
OK1=0
HACKERS=0

     t_echo 2 Verifying anonymous ftp area ${ftphome}

     # Ensure that the /usr/bin directory exists
     if [ ! -d ${ftphome}/usr/bin ]; then
        t_echo 1 Could not locate ${ftphome}/usr/bin - BAD;BADS=`expr $BADS + 1`
     fi
     
     if [ `find ${ftpome}/bin -type l -print` ]; then
        t_echo 2 ${ftphome}/bin linked  - OK;OK=`expr $OK + 1`
	else
        t_echo 0 ${ftphome}/bin local to ftp account - BAD;BADS=`expr $BADS + 1`
     fi

     # Ensure that the /usr/lib and /etc directories exist
     if [ -d ${ftphome}/usr/lib ]; then
        t_echo 2 ${ftphome}/lib exists - OK;OK=`expr $OK + 1`
	else
        t_echo 0 ${ftphome}/lib does not exist - BAD;BADS=`expr $BADS + 1`
     fi
     if [ -d ${ftphome}/etc ]; then
        t_echo 2 ${ftphome}/etc exists - OK;OK=`expr $OK + 1`
	else
        t_echo 0 ${ftphome}/etc does not exist - BAD;BADS=`expr $BADS + 1`
     fi

     #Most of the following are needed for basic operation, except
     #for libnsl.so, nss_nis.so, libsocket.so, and straddr.so which are
     #needed to resolve NIS names.

     for lib in ld.so ld.so.1
	do
	  if [ `ls ${ftphome}/usr/lib/${lib}` ]; then
             t_echo 2 ${ftphome}/usr/lib/${lib} exists - OK;OK=`expr $OK + 1`
	  else
             t_echo 0 ${ftphome}/usr/lib/${lib} does not exist - BAD;BADS=`expr $BADS + 1`
	  fi
     done
	   

     for lib in libc libdl libintl libw libnsl libsocket nss_nis nss_nisplus nss_dns nss_files
     do
	  if [ `ls ${ftphome}/usr/lib/${lib}.so` ]; then
             t_echo 2 ${ftphome}/usr/lib/${lib}.so exists - OK;OK=`expr $OK + 1`
	  else
             t_echo 0 ${ftphome}/usr/lib/${lib}.so does not exist - BAD;BADS=`expr $BADS + 1`
	  fi
     done

     for lib in libc libdl libintl libw libnsl libsocket nss_nis nss_nisplus nss_dns nss_files
     do
	  if [ `ls ${ftphome}/usr/lib/${lib}.so.1` ]; then
             t_echo 2 ${ftphome}/usr/lib/${lib}.so.1 exists - OK;OK=`expr $OK + 1`
	  else
             t_echo 0 ${ftphome}/usr/lib/${lib}.so.1 does not exist - BAD;BADS=`expr $BADS + 1`
	  fi
     done

     if [ `ls ${ftphome}/usr/lib/straddr.so.2` ]; then
        t_echo 2 ${ftphome}/usr/lib/straddr.so.2 exists - OK;OK=`expr $OK + 1`
	else
        t_echo 0 ${ftphome}/usr/lib/straddr.so.2 does not exist - BAD;BADS=`expr $BADS + 1`
     fi

     for file in passwd group netconfig 
       do
	if [ `ls ${ftphome}/etc/${file}` ]; then
           t_echo 2 ${ftphome}/etc/${file} exists - OK;OK=`expr $OK + 1`
 	 else
           t_echo 0 ${ftphome}/etc/${file} does not exist - BAD;BADS=`expr $BADS + 1`
	fi
     done

     # Copy timezone database
     if [ -d ${ftphome}/usr/share/lib/zoneinfo ]; then
          t_echo 2 ${ftphome}/usr/share/lib/zoneinfo exists - OK;OK=`expr $OK + 1`
	else
          t_echo 0 ${ftphome}/usr/share/lib/zoneinfo does not exist - BAD;BADS=`expr $BADS + 1`
     fi

     for zone in `ls /usr/share/lib/zoneinfo`
      do
	TYPE=`ls -ld ${ftphome}/usr/share/lib/zoneinfo/${zone} | cut -c1`

	case $TYPE in
	  l)
          t_echo 0 ${ftphome}/usr/share/lib/zoneinfo/${zone} is link - OK\?;OK1=`expr $OK1 + 1`
          ;;
	  d)
          t_echo 0 ${ftphome}/usr/share/lib/zoneinfo/${zone} is directory - OK\?;OK1=`expr $OK1 + 1`
	  ;;
	  b|c)
          t_echo 0 ${ftphome}/usr/share/lib/zoneinfo/${zone} is device - HACKER\?;HACKERS=`expr $HACKERS + 1`
	  ;;
	  *)
          if [ `find ${ftphome}/usr/share/lib/zoneinfo/${zone} -print` ]; then
             t_echo 2 ${ftphome}/usr/share/lib/zoneinfo/${zone} exists - OK;OK=`expr $OK + 1`
	  else
             t_echo 0 ${ftphome}/usr/share/lib/zoneinfo/${zone} does not exist - BAD;BADS=`expr $BADS + 1`
          fi
	 ;;
	esac
     done

     
     for file in `ls ${ftphome}/usr/lib`
       do
	TYPE=`ls -ld ${ftphome}/usr/lib/${file} | cut -c1`
	case $TYPE in
	  l)
          t_echo 0 ${ftphome}/usr/lib/${file} is link - OK\?;OK1=`expr $OK1 + 1`
          ;;
	  d)
          t_echo 0 ${ftphome}/usr/lib/${file} is directory - OK\?;OK1=`expr $OK1 + 1`
	  ;;
	  b|c)
          t_echo 0 ${ftphome}/usr/share/lib/zoneinfo/${zone} is device - HACKER\?;HACKERS=`expr $HACKERS + 1`
	  ;;
	  *)
	  if [ `find ${ftphome}/usr/lib/${file} -perm 555 -print` ]; then
             t_echo 2 ${ftphome}/usr/lib/${file} perm 555 - OK;OK=`expr $OK + 1`
          else
             t_echo 0 ${ftphome}/usr/lib/${file} NOT perm 555 - BAD;BADS=`expr $BADS + 1`
          fi
	 ;;
	esac
     done

     for file in `ls ${ftphome}/etc`
       do
	TYPE=`ls -ld ${ftphome}/etc/${file} | cut -c1`
	case $TYPE in
	  l)
          t_echo 0 ${ftphome}/etc/${file} is link - OK\?;OK1=`expr $OK1 + 1`
          ;;
	  d)
          t_echo 0 ${ftphome}/etc/${file} is directory - OK\?;OK1=`expr $OK1 + 1`
	  ;;
	  b|c)
          t_echo 0 ${ftphome}/etc/${file} is device - HACKER\?;HACKERS=`expr $HACKERS + 1`
	  ;;
	  *)
	if [ `find ${ftphome}/etc/${file} -perm 444 -print` ]; then
           t_echo 2 ${ftphome}/etc/${file} perm 444 - OK;OK=`expr $OK + 1`
         else
           t_echo 0 ${ftphome}/etc/${file} NOT perm 444 - BAD;BADS=`expr $BADS + 1`
        fi
	 ;;
	esac
     done

     # Ensure that the /dev directory exists
     if [ -d ${ftphome}/dev ]; then
        t_echo 2 ${ftphome}/dev exists - OK;OK=`expr $OK + 1`
     else
        t_echo 0 ${ftphome}/dev does not exist - BAD;BADS=`expr $BADS + 1`
     fi

     for device in zero tcp udp ticotsord
     do
     if [ -r ${ftphome}/dev/${device} ]; then
        t_echo 2 ${ftphome}/dev/${device} exists - OK;OK=`expr $OK + 1`
     else
        t_echo 0 ${ftphome}/dev/${device} does not exist - BAD;BADS=`expr $BADS + 1`
     fi
     done

     for file in `ls ${ftphome}/dev`
       do
	TYPE=`ls -ld ${ftphome}/dev/${file} | cut -c1`
	case $TYPE in
	  l)
          t_echo 0 ${ftphome}/dev/${file} is link - OK\?;OK1=`expr $OK1 + 1`
          ;;
	  d)
          t_echo 0 ${ftphome}/dev/${file} is directory - OK\?;OK1=`expr $OK1 + 1`
	  ;;
	  b|c)
	  if [ `find ${ftphome}/dev/${file} -perm 666 -print` ]; then
             t_echo 0 ${ftphome}/dev/${file} perm 666 - OK;OK=`expr $OK + 1`
          else
             t_echo 0 ${ftphome}/dev/${file} NOT perm 666 - BAD;BADS=`expr $BADS + 1`
          fi
	  ;;
	  *)
          t_echo 0 ${ftphome}/dev/${file} not device/link/directory - HACKER\?;HACKERS=`expr $HACKERS + 1`
	 ;;
	esac
     done

     if [ -d ${ftphome}/pub ]; then
        t_echo 2 ${ftphome}/pub exists - OK;OK=`expr $OK + 1`
     else
        t_echo 0 ${ftphome}/pub does not exist - BAD;BADS=`expr $BADS + 1`
     fi

     if [ `find ${ftphome}/pub -user ftp -print` ]; then
        t_echo 2 ${ftphome}/pub ftp owned - OK;OK=`expr $OK + 1`
     else
        t_echo 0 ${ftphome}/pub not ftp owned - BAD;BADS=`expr $BADS + 1`
     fi

 t_echo 2 " "
 t_echo 2 "Completed verification...... "
 t_echo 2 " "
 t_echo 2 "Valid Findings        - OK       = $OK"
 t_echo 2 "Unknown Findings      - OK\?     = $OK1"
 t_echo 2 "Bad findings          - BAD      = $BADS"
 t_echo 2 "Questionable findings - HACKER\? = $HACKERS"
 t_echo 2 " "
 t_echo 2 "You should review any OK\? entries as soon as possible"
 t_echo 2 "Always review any HACKER\? results NOW since these"
 t_echo 2 "typically point to something out of the ordinary"
 t_echo 2 "such as a device in the ${ftphome}/lib directory"
 t_echo 2 "or a totally unknown file type in ${ftphome}/dev"

} # End VrfyFTPAcct Function

#
# Main functions here
#

Intro() {
cat << EOF 

 Will install/verify your selected FTP service based on command
 line args --- Usage: $MYNAME -f(ix)/-v(erify) <ftpdir>

 In verify mode this script will provide reference on your
 installation in the following manner : 
 
 PASSES CHECK   = Expected file/permission based on Fix mode install
  = May be ok but should be reviewed manually
 FAILS CHECK  = Not expected permission/missing from Fix mode list
 HACKER\? = Something wrong should be reviewed manually
 "
EOF

}

action=$1
case ${action} in
-[Ii]*)
Intro
;;
-[Ff]*)
	MakeFTPAcct
	VrfyFTPAcct
;;
-[Vv]*)
	VrfyFTPAcct
;;
*)
    t_echo 1 ""
           echo "        Usage: $MYNAME -[ifv] [start,<ftphome>]"
    t_echo 1 "        Where: $MYNAME -F/V start - Uses existing ftp dir in /etc/passwd"
    t_echo 1 "       $MYNAME -F/V <ftp-root-dir> - Uses $ftphome to verify/install FTP services"
    t_echo 1 ""
    t_echo 1 "        Must enter a default directory for the ftp service"
    t_echo 1 "        as \$2 - May NOT use either /, /usr, /opt"
    t_echo 1 ""
;;
esac

