:
# inetd2.sh
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0
umask 022

# This tool suite was written by and is copyright by Brad Powell , Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
 
# Some of the ideas and code for the sunos 4.1.X version of titan was 
# modified from code from a program secure_sun author unknown. If the 
# author of secure_sun (i believe it was from Texas A&M) wishes to identify 
# himself/herself I will gladly post credit where it is due- bpowell
 
# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
OS=`uname -r`
HOST=`uname -n`
DATE=`/bin/date +%Y%m%d%H%M`
SAVEFILES='/etc/inetd.conf /etc/inet/inetd.conf'
inetdconf="/etc/inet/inetd.conf"

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
	# exit 1
	:
	fi

Intro() {

cat << EOF_INTRO

 $MYNAME : This is a more restrictive version of inetd.sh. It disables all
 but telnet and ftp in $inetdconf, since they give out information or are 
 potential "denial of service" problems, Things like rexd, finger, systat,
 netstat, rusersd, sprayd, and walld are disabled.
 Additionally in.ftpd gets started with "-l" to log all ftp sessions.

EOF_INTRO

}

Check() {
 
if egrep -s "^finger|^talk|^comsat|^shell|^login|^uucp|^tftp|^name|^printer|^shell|^login" $inetdconf
then
   t_echo 0 " File $inetdconf has services running that should be disabled - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (inetd2.sh -f) See also inetd.sh. This version just "
        t_echo 3 "disables all services except ftp and telnet. It is recommended that Openssh be"
        t_echo 3 "used instead of ftp and telnet (if you know how to configure sshd_config to be"
        t_echo 3 "secure! it isn't by default) "
        t_echo 3 "Titan leaves telnet and ftp enabled to give access in the meantime.  "     
        t_echo 3 " "
        t_echo 3 "Note- Tcp_wrappers should be used on telet and ftp, and consider using a One"
        t_echo 3 "Time Password scheme as well."
        t_echo 3 " "
        t_echo 3 "======================================================================== "

else
   t_echo 1 " $inetdconf seems to have had services disabled: PASSES CHECK"

fi

}

Fix() {

if [ -f $inetdconf.ORIG.$DATE ]
	then
	t_echo 2 "File $inetdconf.ORIG.$DATE already exists; not changing"
else
	t_echo 2 "moving $inetdconf to $inetdconf.ORIG.$DATE"
	mv $inetdconf $inetdconf.ORIG.$DATE
	if [ $? -ne 0 ]
		then   
		t_echo 2
		t_echo 2 "Could not rename inetd.conf"
		exit 1
		fi
	fi

if [  ! -f $inetdconf ]
	then
	t_echo 2 "Changing $inetdconf to the new version"
	t_echo 2 "Note: You may have to manually edit inetd if you add"
	t_echo 2 "non-standard services."
	t_echo 2 "The existing version is saved as $inetdconf.ORIG.$DATE"
	t_echo 2 ""
	t_echo 2 " YOU SHOULD REALLY LOOK TO USING ssh or logdaemon!"

/bin/cat << EOF_INET > $inetdconf

# Configuration file for inetd(8).  See inetd.conf(5).
#
# To re-configure the running inetd process, edit this file, then
# send the inetd process a SIGHUP.
#
# Internet services syntax:
#  <service_name> <socket_type> <proto> <flags> <user> <server_pathname> <args>
#
# Ftp and telnet are standard Internet services.
#
ftp        stream  tcp     nowait  root    /usr/sbin/in.ftpd   in.ftpd -l
telnet  stream  tcp     nowait  root    /usr/sbin/in.telnetd     in.telnetd
EOF_INET

	/bin/chmod 644 $inetdconf
	fi

}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
        t_echo 1 " "
;;
esac

