:
# keyserv2.8.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell; for FILE loop in Fix()
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 3.6 Fri  May 26 08:06:49 PDT 2000 split out solaris 8 changes
# version 4.0.10

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 
#

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
OS=`uname -r`
SAVEFILES='/etc/rc2.d/S71rpc /etc/rc3.d/S71rpc'

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
case "`uname -r`" in
5.[89]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 8 and newer "
        t_echo 1 "use keyserv.sh for older Solaris releases "
        exit 1;;
esac

Intro () {

cat << EOF

 $MYNAME -  Script to start keyserv with the "-d" option so that the 
 default "nobody" key is not allowed. see "man keyserv" for more information.

EOF

}

Fix() {

if [ -f /etc/rc2.d/S??rpc -o -f /etc/rc3.d/S??rpc ]; then
	for FILE in `ls /etc/rc*.d/S??rpc`
	do
	cp -p $FILE `echo $FILE | tr -s S s`.ORIG.$DATE
	 grep -i "/usr/sbin/keyserv -d" $FILE > /dev/null 2>&1
	if [ $? -ne 0 ]; then
 	t_echo 2 "        In $FILE keyserv is running without the -d flag ; REPAIRING"


	ed - $FILE <<- !
		g/^[	][	]\/usr\/sbin\/keyserv\ */s//		\/usr\/sbin\/keyserv\ \-d\ /g

		.
		w
		q
		!
	fi
done
	else
	 t_echo 1 "        /etc/rc?.d/S??rpc does not exist  - PASSES CHECK"
fi

}

Check() {

if [ -f /etc/rc2.d/S??rpc -o -f /etc/rc3.d/S??rpc ]; then
      for FILE in `ls /etc/rc*.d/S??rpc`
       do
	grep -i "/usr/sbin/keyserv -d" /etc/rc2.d/S*rpc
	if [ $? -ne 0 ]; then
 t_echo 0 "        File $FILE keyserv ; user nobody enabled - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (keyserv2.8.sh -f) Keyserv should be started with the -d "
        t_echo 3 "option (or disabled) This will restrict RPC connections from anonymous user "
        t_echo 3 "nobody "
        t_echo 3 "Also see the manpages for nisauthconf(1M),  publickey(4), newkey(1M) and"
        t_echo 3 "secure_rpc."
        t_echo 3 " "
        t_echo 3 "======================================================================== "

	else
 t_echo 1 "         File $FILE keyserv user nobody disallowed - PASSES CHECK"
	fi
      done
else
    t_echo 1 "        /etc/rc?.d/S??rpc does not exist  - PASSES CHECK"

fi

}

action=$1
	case ${action} in
	-[Ii]*)
	Intro
	;;
	 -[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
 t_echo 1 "        ERROR:Invalid arg $action"
 t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 t_echo 1 " "
	;;
	esac

