:
# log-tcp.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.0.3 Fri Jan  8 12:42:25 PST 1999 bpowell
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0.10

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/rc2.d/S72inetsvc'

. misc_functions.sh

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

Intro() {

cat << EOF
 
 $MYNAME - Changes the in.inetd startup configuration to use 
 the "-t" flag in /etc/rc2.d/S72inetsvc. 

 From the inetd man page:

	-t 	Instructs inetd to trace the incoming  connections
               	for all of its TCP services.  It does this by log-
               	ging the client's IP address and TCP port  number,
               	along with the name of the service, using the sys-
               	log(3) facility.
EOF

}

Fix() {

 if [ -f /etc/rc2.d/S??inetsvc ]; then
        grep -i "^\/usr\/sbin\/inetd\ \-s\ \-t$" /etc/rc2.d/S??inetsvc
        if [ $? -eq 0 ]; then
	t_echo 2 " /etc/rc2.d/S??inetsvc is already running -t  - Not Changing"
	exit 1
	else
        if [ -f /etc/rc2.d/S??inetsvc ]; then
        t_echo 2 " Saving /etc/rc2.d/S??inetsvc to /etc/rc2.d/s??inetsvc.ORIG.${DATE}"
        cp -p /etc/rc2.d/S??inetsvc /etc/rc2.d/s72inetsvc.ORIG.${DATE}
	if [ $? -ne 0 ]; then
           t_echo 1 "     Could not save file to /etc/rc2.d/s72inetsvc.ORIG.${DATE} - ERROR"
           exit 1
	else
	t_echo 2     " Changing inetd startup default "
	ed /etc/rc2.d/S??inetsvc <<- EDEND
	g/^\/usr\/sbin\/inetd/s/\/usr\/sbin\/inetd\ \-s/\/usr\/sbin\/inetd\ \-s\ \-t/
	.
        w
	q
	EDEND
           t_echo 2 " inetd startup in /etc/rc2.d/S??inetsvc changed ... "
          fi
        fi
	fi
 fi

}

Check() {

        if [ -f /etc/rc2.d/S??inetsvc ]; then
	grep -i "^\/usr\/sbin\/inetd\ \-s$" /etc/rc2.d/S??inetsvc
	if [ $? -eq 0 ]; then
 	 t_echo 0 "       /etc/rc2.d/S??inetsvc - has the system default . - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (log-tcp.sh -f) Inetd should be set to start with"
        t_echo 3 "the -t flag."
        t_echo 3 "edit /etc/rc2.d/S69inet and change: "
        t_echo 3 "    FROM: " 
        t_echo 3 "    /usr/sbin/inetd -s "
        t_echo 3 "    TO: "
        t_echo 3 "    /usr/sbin/inetd -s -t "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

         else
	fix=`grep "^\/usr\/sbin\/inetd\ \-s\ \-t*" /etc/rc2.d/S??inetsvc`
	if [ $? -eq 0 ]; then
         t_echo 1 "  /etc/rc2.d/S??inetsvc : -  PASSES CHECK" 
	fi
	fi
         fi
}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

