:
# nfs-portmon.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/system'
OS=`uname -r`

# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

#
# suck in some lib functions (t_echo, etc.)
#
. misc_functions.sh

Intro () {

cat << EOF

 $MYNAME : Enables NFS port monitoring by adding to /etc/system:

	set nfssrv:nfs_portmon = 1
	set nfs:nfs_portmon = 1


EOF

}

Fix() {
                                                              
   if [ -f /etc/system ]; then                                
      if grep "^[ ]*set[ ]*nfsserver:nfs_portmon" /etc/system >/dev/null ; then
      t_echo 1 "nfs port monitoring already enabled"     
      exit 0                                             
      fi               
   fi

   if [ -f /etc/system ]; then
     t_echo 2 " Saving /etc/system to /etc/system.ORIG.$DATE"
     cp -p /etc/system /etc/system.ORIG.$DATE
       if [ $? -ne 0 ]; then
       t_echo 1 "     ERROR - Could not rename /etc/system; exiting"
       exit 1
    else
      t_echo 2 " Changing /etc/system enabling port monitoring"
       echo "set nfssrv:nfs_portmon = 1" >>/etc/system
       chmod 644 /etc/system
        t_echo 2 "NFS server port monitoring enabled  ... "
       fi
    fi

    if [ ! -f /etc/system ]; then
       touch /etc/system
       t_echo 2 " Creating /etc/system enabling port monitoring"
       echo "* added to enable port monitoring" >>/etc/system
#       echo "set nfs:nfs_portmon = 1" >>/etc/system
        echo "set nfssrv:nfs_portmon = 1" >>/etc/system
        chmod 644 /etc/system
    fi
# 
}

Check() {

        if [ -f /etc/system ]; then
         grep "nfs_portmon" /etc/system | grep -v "#" >/dev/null 2>&-
         if [ $? -eq 0 ]; then
            t_echo 1 "        NFS port monitor enabled - PASSES CHECK"
	    exit 1
         else
            t_echo 0 "        NFS port monitor disabled - FAILS CHECK"
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (nfs-portmon.sh -f) Enable NFS port monitoring by adding to"         
        t_echo 3 "/etc/system: "
        t_echo 3 " "
        t_echo 3 "    set nfssrv:nfs_portmon = 1 "
        t_echo 3 "    set nfs:nfs_portmon = 1 "
        t_echo 3 " "
        t_echo 3 "======================================================================== "

         fi
        else
           t_echo 1 "         ERROR No /etc/system file - cannot verify"
           exit 1
        fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

#finis
