:
# pam-rhosts-2.6.sh
# version 3.0 Sep 25 11:21:02 PDT 1998
# version 3.4 Wed Feb 16 08:33:18 PST 2000 savefile variable added
# version 4.0 BETA2

umask 022
# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001
#
# The copyright holder disclaims all responsibility or liability with 
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE" 
# document which accompanies distribution. 

# setup
TITANHOME=`pwd`
PATH=/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
DATE=`/bin/date +%m%d%y%H%M`
SAVEFILES='/etc/pam.conf'

. misc_functions.sh

case "`uname -r`" in
5.[6789]*) ;;
*)
        t_echo 1 "$MYNAME ERROR - This script is Only supported on Solaris 2.6 and newer, please use one of the other scripts for your OS "
        exit 1;;
esac


# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

# Quick arg check


Intro() {

cat << EOF

 $MYNAME - This Script saves and modifies the /etc/pam.conf file removing
 the line:

 rlogin  auth sufficient /usr/lib/security/pam_rhosts_auth.so.1

 and removing the rsh line forcing rsh to use the "other" function which we
preset to force auth on all services :

 other     auth required   /usr/lib/security/pam_unix.so.1

EOF

}

Fix() {

if [ -f /etc/pam.conf ]; then
 t_echo 2     " Saving /etc/pam.conf to /etc/pam.conf.ORIG.$DATE "
 mv /etc/pam.conf /etc/pam.conf.ORIG.$DATE
 chmod 0100 /etc/pam.conf.ORIG.$DATE 
 if [ $? -ne 0 ]; then
   t_echo 1 "     ERROR:Could not save /etc/pam.conf ; exiting"
   exit 1
  else
    t_echo 2 "Save complete ... "
  fi
fi

t_echo 2     " Creating new /etc/pam.conf file"

if [ -f /etc/pam.conf.ORIG.$DATE ] ; then
 cat << EOF_PAM > /etc/pam.conf
#ident  "@(#)pam.conf 1.19 titan 98/01/30 SMI"
#
# PAM configuration
#
# Authentication management
#
login   auth required   /usr/lib/security/pam_unix.so.1
login   auth required   /usr/lib/security/pam_dial_auth.so.1
#
rlogin  auth required   /usr/lib/security/pam_unix.so.1
#
dtlogin auth required   /usr/lib/security/pam_unix.so.1
#
other   auth required   /usr/lib/security/pam_unix.so.1
#
# Account management
#
login   account required        /usr/lib/security/pam_unix.so.1
dtlogin account required        /usr/lib/security/pam_unix.so.1
#
other   account required        /usr/lib/security/pam_unix.so.1
#
# Session management
#
other   session required        /usr/lib/security/pam_unix.so.1
#
# Password management
#
other   password required       /usr/lib/security/pam_unix.so.1
EOF_PAM
 chmod 644 /etc/pam.conf

 else
	t_echo 1 " Can't find saved file too dangerous to proceed - ERROR"
 fi

}

Check() {

BROKEN=`grep -s "^rlogin\ \ auth\ sufficient" /etc/pam.conf`

	if [ -z "$BROKEN" ]; then
         t_echo 1 "   PAM doesn't allow rhosts for rlogin to succeed : PASSES CHECK"
         else
         t_echo 0 "  PAM allows rhosts for rlogin : FAILS CHECK" 
        t_echo 3 " "
        t_echo 3 "Titan Recommendation: (pam-rhosts-2.6.sh -f) By default Plugable Authentication"
        t_echo 3 "Module (PAM) is configured to allow rhosts. it is recommended that
this default"
        t_echo 3 "be changed to not allow rhosts. Titan removes the following line: "        t_echo 3 "    rlogin auth sufficient /usr/lib/security/pam_rhosts_auth.so.1 "        t_echo 3 "    And changes the default to: "
        t_echo 3 "    other     auth required   /usr/lib/security/pam_unix.so.1 "
        t_echo 3 "  "
        t_echo 3 "======================================================================== "

         fi

BROKEN2=`grep -s "^rsh" /etc/pam.conf`
	if [ -z "$BROKEN2" ]; then
	 t_echo 1 "   PAM doesn't allow rhosts for rsh to succeed : PASSES CHECK"
         else
         t_echo 0 "  PAM allows rhosts for rsh : FAILS CHECK"
         fi

}

action=$1

   case ${action} in
	-[Ii]*)
	Intro
	;;
	-[Ff]*)
	Fix
	;;
	-[Vv]*)
	Check
	;;
	*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $0 -[ivf] (I)ntro/(V)erify/(F)ix"
	exit 1;;
	esac

